﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Drawing;

namespace howto_interlocked_circles
{
    public static class Extensions
    {
        // Draw a thick arc with different inside and outside pens.
        public static void DrawThickArc(this Graphics gr, PointF center, float radius,
            float start_angle, float sweep_angle,
            Pen fill_pen, Pen outline_pen)
        {
            // Draw the main arc.
            gr.DrawArc(fill_pen,
                center.X - radius,
                center.Y - radius,
                2 * radius, 2 * radius,
                start_angle, sweep_angle);

            // Draw the outer outline.
            float r1 = radius + fill_pen.Width / 2f + outline_pen.Width / 2f;
            gr.DrawArc(outline_pen,
                center.X - r1,
                center.Y - r1,
                2 * r1, 2 * r1,
                start_angle, sweep_angle);

            // Draw the inner outline.
            float r2 = radius - fill_pen.Width / 2f - outline_pen.Width / 2f;
            gr.DrawArc(outline_pen,
                center.X - r2,
                center.Y - r2,
                2 * r2, 2 * r2,
                start_angle, sweep_angle);
        }
    }
}
